Index: Makefile.in
===================================================================
--- Makefile.in	(revision 2bdfed9634a0f1ee28b359eca2d69367877f17fb)
+++ Makefile.in	(revision 47519e1bcab60a6026c4192bf5b20290f37f4737)
@@ -26,5 +26,5 @@
      keypress.c keymap.c keybinding.c cmd.c context.c zcrypt.c \
      aim.c buddy.c buddylist.c timer.c style.c stylefunc.c errqueue.c \
-     zbuddylist.c muxevents.c popexec.c obarray.c
+     zbuddylist.c muxevents.c popexec.c obarray.c wcwidth.c
 OWL_SRC = owl.c
 TESTER_SRC = tester.c
Index: editwin.c
===================================================================
--- editwin.c	(revision 9a6cc4036c2f0cba0fbe1e53b8f2bbb02333684c)
+++ editwin.c	(revision 47519e1bcab60a6026c4192bf5b20290f37f4737)
@@ -143,8 +143,9 @@
   e->buffy=0;
   owl_editwin_overwrite_string(e, text);
+  owl_editwin_overwrite_char(e, '\0');
   e->lock=strlen(text);
   /* if (text[e->lock-1]=='\n') e->lock--; */
-  e->buffx=x;
-  e->buffy=y;
+  /*  e->buffx=x; */
+  /*  e->buffy=y; */
   owl_editwin_adjust_for_locktext(e);
   owl_editwin_redisplay(e, 0);
@@ -251,55 +252,84 @@
 
   /* start at topline */
-  ptr1=e->buff;
-  for (i=0; i<e->topline; i++) {
-    ptr2=strchr(ptr1, '\n');
+  ptr1 = e->buff;
+  for (i = 0; i < e->topline; i++) {
+    ptr2 = strchr(ptr1, '\n');
     if (!ptr2) {
       /* we're already on the last line */
       break;
     }
-    ptr1=ptr2+1;
+    ptr1 = ptr2 + 1;
   }
   /* ptr1 now stores the starting point */
 
   /* find the ending point and store it in ptr3 */
-  ptr2=ptr1;
-  ptr3=ptr1;
-  for (i=0; i<e->winlines; i++) {
-    ptr3=strchr(ptr2, '\n');
+  ptr2 = ptr1;
+  ptr3 = ptr1;
+  for (i = 0; i < e->winlines; i++) {
+    ptr3 = strchr(ptr2, '\n');
     if (!ptr3) {
       /* we've hit the last line */
       /* print everything to the end */
-      ptr3=e->buff+e->bufflen-1;
+      ptr3 = e->buff + e->bufflen - 1;
       ptr3--;
       break;
     }
-    ptr2=ptr3+1;
-  }
-  ptr3+=2;
-
-  buff=owl_malloc(ptr3-ptr1+50);
-  strncpy(buff, ptr1, ptr3-ptr1);
-  buff[ptr3-ptr1]='\0';
-  if (e->echochar=='\0') {
+    ptr2 = ptr3 + 1;
+  }
+  ptr3 += 2;
+
+  buff = owl_malloc(ptr3 - ptr1 + 50);
+  strncpy(buff, ptr1, ptr3 - ptr1);
+  buff[ptr3 - ptr1] = '\0';
+  if (e->echochar == '\0') {
     waddstr(e->curswin, buff);
   } else {
     /* translate to echochar, *except* for the locktext */
     int len;
-    int dolocklen=e->lock-(ptr1-e->buff);
-
-    for (i=0; i<dolocklen; i++) {
+    int dolocklen = e->lock - (ptr1 - e->buff);
+
+    for (i = 0; i < dolocklen; i++) {
       waddch(e->curswin, buff[i]);
     }
-    len=strlen(buff);
-    for (i=0; i<len-dolocklen; i++) {
+    len = strlen(buff);
+    for (i = 0; i < len-dolocklen; i++) {
       waddch(e->curswin, e->echochar);
     }
   }
-  wmove(e->curswin, e->buffy-e->topline, e->buffx);
+  wmove(e->curswin, e->buffy-e->topline, e->buffx + _owl_editwin_cursor_adjustment(e));
   wnoutrefresh(e->curswin);
-  if (update==1) {
+  if (update == 1) {
     doupdate();
   }
   owl_free(buff);
+}
+
+/* Remove n bytes at cursor. */
+void _owl_editwin_remove_bytes(owl_editwin *e, int n) /*noproto*/
+{
+  int i = _owl_editwin_get_index_from_xy(e) + n;
+  for (; i < e->bufflen; i++) {
+    e->buff[i-n] = e->buff[i];
+  }
+  
+  e->bufflen -= n;
+  e->buff[e->bufflen] = '\0';
+}
+/* Insert n bytes at cursor.*/
+void _owl_editwin_insert_bytes(owl_editwin *e, int n) /*noproto*/
+{
+  int i, z;
+  
+  if ((e->bufflen + n) > (e->allocated - 5)) {
+    _owl_editwin_addspace(e);
+  }
+
+  e->bufflen += n;
+  e->buff[e->bufflen] = '\0';
+  
+  z = _owl_editwin_get_index_from_xy(e);
+  for (i = e->bufflen - 1; i > z; i--) {
+    e->buff[i] = e->buff[i - n];
+  }
 }
 
@@ -313,17 +343,17 @@
   int i, z;
 
-  z=_owl_editwin_get_index_from_xy(e);
+  z = _owl_editwin_get_index_from_xy(e);
   /* move back and line wrap the previous word */
-  for (i=z-1; ; i--) {
+  for (i = z - 1; ; i--) {
     /* move back until you find a space or hit the beginning of the line */
-    if (e->buff[i]==' ') {
+    if (e->buff[i] == ' ') {
       /* replace the space with a newline */
-      e->buff[i]='\n';
+      e->buff[i] = '\n';
       e->buffy++;
-      e->buffx=z-i-1;
+      e->buffx = z - i - 1;
       /* were we on the last line */
       return(0);
-    } else if (e->buff[i]=='\n' || i<=e->lock) {
-      /* we hit the begginning of the line or the buffer, we cannot
+    } else if (e->buff[i] == '\n' || i <= e->lock) {
+      /* we hit the beginning of the line or the buffer, we cannot
        * wrap.
        */
@@ -336,15 +366,16 @@
  * characters over)
  */
-void owl_editwin_insert_char(owl_editwin *e, char c)
-{
-  
-  int z, i, ret;
-
+void owl_editwin_insert_char(owl_editwin *e, gunichar c)
+{
+  int z, i, ret, len;
+  char tmp[6];
+  memset(tmp, '\0', 6);
+  
   /* \r is \n */
-  if (c=='\r') {
-    c='\n';
-  }
-
-  if (c=='\n' && e->style==OWL_EDITWIN_STYLE_ONELINE) {
+  if (c == '\r') {
+    c = '\n';
+  }
+
+  if (c == '\n' && e->style == OWL_EDITWIN_STYLE_ONELINE) {
     /* perhaps later this will change some state that allows the string
        to be read */
@@ -352,16 +383,19 @@
   }
 
+  g_unichar_to_utf8(c, tmp);
+  len = strlen(tmp);
+  
   /* make sure there is enough memory for the new text */
-  if ((e->bufflen+1) > (e->allocated-5)) {
+  if ((e->bufflen + len) > (e->allocated - 5)) {
     _owl_editwin_addspace(e);
   }
 
   /* get the insertion point */
-  z=_owl_editwin_get_index_from_xy(e);
+  z = _owl_editwin_get_index_from_xy(e);
 
   /* If we're going to insert at the last column do word wrapping, unless it's a \n */
-  if ((e->buffx+1==e->wrapcol) && (c!='\n')) {
-    ret=_owl_editwin_linewrap_word(e);
-    if (ret==-1) {
+  if ((e->buffx + 1 == e->wrapcol) && (c != '\n')) {
+    ret = _owl_editwin_linewrap_word(e);
+    if (ret == -1) {
       /* we couldn't wrap, insert a hard newline instead */
       owl_editwin_insert_char(e, '\n');
@@ -369,37 +403,34 @@
   }
 
-  z=_owl_editwin_get_index_from_xy(e);
   /* shift all the other characters right */
-  for (i=e->bufflen; i>z; i--) {
-    e->buff[i]=e->buff[i-1];
-  }
-
-  /* insert the new one */
-  e->buff[z]=c;
+  _owl_editwin_insert_bytes(e, len);
+
+  /* insert the new character */
+  for(i = 0; i < len; i++) {
+    e->buff[z + i] = tmp[i];
+  }
 
   /* housekeeping */
-  e->bufflen++;
-  e->buff[e->bufflen]='\0';
+  e->bufflen += len;
+  e->buff[e->bufflen] = '\0';
 
   /* advance the cursor */
-  if (c=='\n') {
-    e->buffx=0;
-    e->buffy++;
-  } else {
-    e->buffx++;
-  }
+  z += len;
+  _owl_editwin_set_xy_by_index(e, z);
 }
 
 /* overwrite the character at the current point with 'c' */
-void owl_editwin_overwrite_char(owl_editwin *e, char c)
-{
-  int z;
+void owl_editwin_overwrite_char(owl_editwin *e, gunichar c)
+{
+  int z, oldlen, newlen, i;
+  char tmp[6];
+  memset(tmp, '\0', 6);
   
   /* \r is \n */
-  if (c=='\r') {
-    c='\n';
-  }
-
-  if (c=='\n' && e->style==OWL_EDITWIN_STYLE_ONELINE) {
+  if (c == '\r') {
+    c = '\n';
+  }
+
+  if (c == '\n' && e->style == OWL_EDITWIN_STYLE_ONELINE) {
     /* perhaps later this will change some state that allows the string
        to be read */
@@ -407,29 +438,34 @@
   }
 
-  z=_owl_editwin_get_index_from_xy(e);
-
-  /* only if we are at the end of the buffer do we create new space */
-  if (z==e->bufflen) {
-    if ((e->bufflen+1) > (e->allocated-5)) {
-      _owl_editwin_addspace(e);
-    }
-  }
-  
-  e->buff[z]=c;
-
-  /* housekeeping if we are at the end of the buffer */
-  if (z==e->bufflen) {
-    e->bufflen++;
-    e->buff[e->bufflen]='\0';
-  }
+  g_unichar_to_utf8(c, tmp);
+  newlen = strlen(tmp);
+
+  z = _owl_editwin_get_index_from_xy(e);
+  {
+    char *t = g_utf8_find_next_char(e->buff + z, NULL);
+    oldlen = (t ? (t - (e->buff + z)) : 1);
+  }
+
+  if ((e->bufflen + newlen - oldlen + 1) > (e->allocated - 5)) {
+    _owl_editwin_addspace(e);
+  }
+
+  if (oldlen > newlen) {
+    _owl_editwin_remove_bytes(e, oldlen-newlen);
+  }
+  else /* oldlen < newlen */ {
+    _owl_editwin_insert_bytes(e, newlen-oldlen);
+  }
+  /* Overwrite the old char*/
+  for (i = 0; i < newlen; i++) {
+    e->buff[z+i] = tmp[i];
+  }
+       
+  /* housekeeping */
+  e->buff[e->bufflen] = '\0';
 
   /* advance the cursor */
-  if (c=='\n') {
-    e->buffx=0;
-    e->buffy++;
-  } else {
-    e->buffx++;
-  }
-
+  z += newlen;
+  _owl_editwin_set_xy_by_index(e, z);
 }
 
@@ -439,18 +475,23 @@
 void owl_editwin_delete_char(owl_editwin *e)
 {
-  int z, i;
-
-  if (e->bufflen==0) return;
+  int z;
+  char *p1, *p2;
+  gunichar c;
+
+  if (e->bufflen == 0) return;
   
   /* get the deletion point */
-  z=_owl_editwin_get_index_from_xy(e);
-
-  if (z==e->bufflen) return;
-
-  for (i=z; i<e->bufflen; i++) {
-    e->buff[i]=e->buff[i+1];
-  }
-  e->bufflen--;
-  e->buff[e->bufflen]='\0';
+  z = _owl_editwin_get_index_from_xy(e);
+
+  if (z == e->bufflen) return;
+
+  p1 = e->buff + z;
+  p2 = g_utf8_next_char(p1);
+  c = g_utf8_get_char(p2);
+  while (g_unichar_ismark(c)) {
+    p2 = g_utf8_next_char(p2);
+    c = g_utf8_get_char(p2);
+  }
+  _owl_editwin_remove_bytes(e, p2-p1);
 }
 
@@ -463,25 +504,43 @@
 {
   int z;
-  char tmp;
-
-  if (e->bufflen==0) return;
+  char *p1, *p2, *p3, *tmp;
+
+  if (e->bufflen == 0) return;
   
   /* get the cursor point */
-  z=_owl_editwin_get_index_from_xy(e);
-
-  if (z==e->bufflen) {
+  z = _owl_editwin_get_index_from_xy(e);
+
+  if (z == e->bufflen) {
     /* point is after last character */
     z--;
   }  
 
-  if (z-1 < e->lock) {
+  if (z - 1 < e->lock) {
     /* point is at beginning of buffer, do nothing */
     return;
   }
 
-  tmp=e->buff[z];
-  e->buff[z]=e->buff[z-1];
-  e->buff[z-1]=tmp;
-  owl_editwin_key_right(e);
+  /* Transpose two utf-8 unicode glyphs. */
+  p1 = e->buff + z;
+
+  p2 = g_utf8_find_next_char(p1, NULL);
+  while (p2 != NULL && g_unichar_ismark(g_utf8_get_char(p2))) {
+    p2 = g_utf8_find_next_char(p2, NULL);
+  }
+  if (p2 == NULL) return;
+
+  p3 = g_utf8_find_prev_char(e->buff, p1);
+  while (p3 != NULL && g_unichar_ismark(g_utf8_get_char(p3))) {
+    p3 = g_utf8_find_prev_char(p3, NULL);
+  }
+  if (p3 == NULL) return;
+
+  tmp = owl_malloc(p2 - p3 + 5);
+  *tmp = '\0';
+  strncat(tmp, p1, p2 - p1);
+  strncat(tmp, p3, p1 - p3);
+  strncpy(p3, tmp, p2 - p3);
+  owl_free(tmp);
+  _owl_editwin_set_xy_by_index(e, p3 - e->buff);
 }
 
@@ -491,9 +550,16 @@
 void owl_editwin_insert_string(owl_editwin *e, char *string)
 {
-  int i, j;
-
-  j=strlen(string);
-  for (i=0; i<j; i++) {
-    owl_editwin_insert_char(e, string[i]);
+  char *p;
+  gunichar c;
+  if (!g_utf8_validate(string, -1, NULL)) {
+    owl_function_debugmsg("owl_editwin_insert_string: received non-utf-8 string.");
+    return;
+  }
+  p = string;
+  c = g_utf8_get_char(p);
+  while (c) {
+    owl_editwin_process_char(e, c);
+    p = g_utf8_next_char(p);
+    c = g_utf8_get_char(p);
   }
 }
@@ -505,9 +571,17 @@
 void owl_editwin_overwrite_string(owl_editwin *e, char *string)
 {
-  int i, j;
-
-  j=strlen(string);
-  for (i=0; i<j; i++) {
-    owl_editwin_overwrite_char(e, string[i]);
+  char *p;
+  gunichar c;
+
+  if (!g_utf8_validate(string, -1, NULL)) {
+    owl_function_debugmsg("owl_editwin_overwrite_string: received non-utf-8 string.");
+    return;
+  }
+  p = string;
+  c = g_utf8_get_char(p);
+  while (c) {
+    owl_editwin_overwrite_char(e, c);
+    p = g_utf8_next_char(p);
+    c = g_utf8_get_char(p);
   }
 }
@@ -520,48 +594,94 @@
   int i;
   char *ptr1, *ptr2;
-
-  if (e->bufflen==0) return(0);
+  gunichar c;
+
+  if (e->bufflen == 0) return(0);
   
   /* first go to the yth line */
-  ptr1=e->buff;
-  for (i=0; i<e->buffy; i++) {
-    ptr2=strchr(ptr1, '\n');
+  ptr1 = e->buff;
+  for (i = 0; i < e->buffy; i++) {
+    ptr2= strchr(ptr1, '\n');
     if (!ptr2) {
       /* we're already on the last line */
       break;
     }
-    ptr1=ptr2+1;
-  }
-
-  /* now go to the xth character */
-  ptr2=strchr(ptr1, '\n');
-  if (!ptr2) {
-    ptr2=e->buff+e->bufflen;
-  }
-
-  if ((ptr2-ptr1) < e->buffx) {
-    ptr1=ptr2-1;
-  } else {
-    ptr1+=e->buffx;
-  }
-
-  /* printf("DEBUG: index is %i\r\n", ptr1-e->buff); */
-  return(ptr1-e->buff);
+    ptr1 = ptr2 + 1;
+  }
+
+  /* now go to the xth cell */
+  ptr2 = ptr1;
+  i = 0;
+  while (ptr2 != NULL && i < e->buffx && (ptr2 - e->buff) < e->bufflen) {
+    c = g_utf8_get_char(ptr2);
+    i += (c == '\n' ? 1 : mk_wcwidth(c));
+    ptr2 = g_utf8_next_char(ptr2);
+  }
+  while(ptr2 != NULL && g_unichar_ismark(g_utf8_get_char(ptr2))) {
+    ptr2 = g_utf8_next_char(ptr2);
+  }
+  if (ptr2 == NULL) return e->bufflen;
+  return(ptr2 - e->buff);
 }
 
 void _owl_editwin_set_xy_by_index(owl_editwin *e, int index)
 {
-  int z, i;
-
-  z=_owl_editwin_get_index_from_xy(e);
-  if (index>z) {
-    for (i=0; i<index-z; i++) {
-      owl_editwin_key_right(e);
-    }
-  } else if (index<z) {
-    for (i=0; i<z-index; i++) {
-      owl_editwin_key_left(e);
-    }
-  }
+  char *ptr1, *ptr2, *target;
+  gunichar c;
+
+  e->buffx = 0;
+  e->buffy = 0;
+
+  ptr1 = e->buff;
+  target = ptr1 + index;
+  /* target sanitizing */
+  if ((target[0] & 0x80) && (~target[0] & 0x40)) {
+    /* middle of a utf-8 character, back up to previous character. */
+    target = g_utf8_find_prev_char(e->buff, target);
+  }
+  c = g_utf8_get_char(target);
+  while (g_unichar_ismark(c) && target > e->buff) {
+    /* Adjust the target off of combining characters and the like. */
+    target = g_utf8_find_prev_char(e->buff, target);
+    c = g_utf8_get_char(target);
+  }
+  /* If we start with a mark, something is wrong.*/
+  if (g_unichar_ismark(c)) return;
+
+  /* Now our target should be acceptable. */
+  ptr2 = strchr(ptr1, '\n');
+  while (ptr2 != NULL && ptr2 < target) {
+    e->buffy++;
+    ptr1 = ptr2 + 1;
+    ptr2 = strchr(ptr1, '\n');
+  }
+  ptr2 = ptr1;
+  while (ptr2 != NULL && ptr2 < target) {
+    c = g_utf8_get_char(ptr2);
+    e->buffx += mk_wcwidth(c);
+    ptr2 = g_utf8_next_char(ptr2);
+  }
+}
+
+int _owl_editwin_cursor_adjustment(owl_editwin *e)
+{
+  char *ptr1, *ptr2;
+  gunichar c;
+  int x, i;
+
+  ptr1 = e->buff;
+  ptr2 = strchr(ptr1, '\n');
+  for (i = 0; ptr2 != NULL && i < e->buffy; i++) {
+    ptr1 = ptr2 + 1;
+    ptr2 = strchr(ptr1, '\n');
+  }
+  ptr2 = ptr1;
+  x = 0;
+  while (ptr2 != NULL && x < e->buffx) {
+    if (*ptr2 == '\n') return 0;
+    c = g_utf8_get_char(ptr2);
+    x += mk_wcwidth(c);
+    ptr2 = g_utf8_next_char(ptr2);
+  }
+  return x - e->buffx;
 }
 
@@ -570,5 +690,5 @@
   /* if we happen to have the cursor over locked text
    * move it to be out of the locktext region */
-  if (_owl_editwin_get_index_from_xy(e)<e->lock) {
+  if (_owl_editwin_get_index_from_xy(e) < e->lock) {
     _owl_editwin_set_xy_by_index(e, e->lock);
   }
@@ -590,6 +710,6 @@
 {
   if (e->buffy > 0) e->buffy--;
-  if (e->buffx >= owl_editwin_get_numchars_on_line(e, e->buffy)) {
-    e->buffx=owl_editwin_get_numchars_on_line(e, e->buffy);
+  if (e->buffx >= owl_editwin_get_numcells_on_line(e, e->buffy)) {
+    e->buffx=owl_editwin_get_numcells_on_line(e, e->buffy);
   }
 
@@ -608,6 +728,6 @@
 
   /* if we're past the last character move back */
-  if (e->buffx >= owl_editwin_get_numchars_on_line(e, e->buffy)) {
-    e->buffx=owl_editwin_get_numchars_on_line(e, e->buffy);
+  if (e->buffx >= owl_editwin_get_numcells_on_line(e, e->buffy)) {
+    e->buffx=owl_editwin_get_numcells_on_line(e, e->buffy);
   }
 
@@ -623,15 +743,17 @@
 void owl_editwin_key_left(owl_editwin *e)
 {
-  /* move left if we can, and maybe up a line */
-  if (e->buffx>0) {
-    e->buffx--;
-  } else if (e->buffy>0) {
-    e->buffy--;
-    e->buffx=owl_editwin_get_numchars_on_line(e, e->buffy);
-  }
-
-  /* do we need to scroll up? */
-  if (e->buffy-e->topline < 0) {
-    e->topline-=e->winlines/2;
+  int i;
+  char * p;
+  i = _owl_editwin_get_index_from_xy(e);
+  p = e->buff + i;
+  p = g_utf8_find_prev_char(e->buff, p);
+  while (p && g_unichar_ismark(g_utf8_get_char(p))) {
+    p = g_utf8_find_prev_char(e->buff, p);
+  }
+  if (p == NULL) p = e->buff;
+  _owl_editwin_set_xy_by_index(e, p - e->buff);
+
+  if (e->buffy - e->topline < 0) {
+    e->topline -= e->winlines / 2;
   }
 
@@ -643,20 +765,21 @@
 {
   int i;
-
-  /* move right if we can, and skip down a line if needed */
-  i=owl_editwin_get_numchars_on_line(e, e->buffy);
-  if (e->buffx < i) {
-    e->buffx++;
-    /*  } else if (e->buffy+1 < owl_editwin_get_numlines(e)) { */
-  } else if (_owl_editwin_get_index_from_xy(e) < e->bufflen) {
-    if (e->style==OWL_EDITWIN_STYLE_MULTILINE) {
-      e->buffx=0;
-      e->buffy++;
-    }
+  char * p;
+  i = _owl_editwin_get_index_from_xy(e);
+  p = e->buff + i;
+  p = g_utf8_find_next_char(p, NULL);
+  while (p && g_unichar_ismark(g_utf8_get_char(p))) {
+    p = g_utf8_find_next_char(p, NULL);
+  }
+  if (p == NULL) {
+    _owl_editwin_set_xy_by_index(e, e->bufflen);
+  }
+  else {
+    _owl_editwin_set_xy_by_index(e, p - e->buff);
   }
 
   /* do we need to scroll down? */
-  if (e->buffy-e->topline >= e->winlines) {
-    e->topline+=e->winlines/2;
+  if (e->buffy - e->topline >= e->winlines) {
+    e->topline += e->winlines / 2;
   }
 }
@@ -664,4 +787,5 @@
 void owl_editwin_move_to_nextword(owl_editwin *e)
 {
+  /* asedeno: needs fixing for utf-8*/
   int i, x;
 
@@ -703,4 +827,5 @@
 void owl_editwin_move_to_previousword(owl_editwin *e)
 {
+  /* asedeno: needs fixing for utf-8*/
   int i, x;
 
@@ -738,4 +863,5 @@
 void owl_editwin_delete_nextword(owl_editwin *e)
 {
+  /* asedeno: needs fixing for utf-8*/
   int z;
 
@@ -768,4 +894,5 @@
 void owl_editwin_delete_previousword(owl_editwin *e)
 {
+  /* asedeno: needs fixing for utf-8*/
   /* go backwards to the last non-space character, then delete chars */
   int i, startpos, endpos;
@@ -781,7 +908,8 @@
 void owl_editwin_delete_to_endofline(owl_editwin *e)
 {
+  /* asedeno: needs fixing for utf-8*/
   int i;
 
-  if (owl_editwin_get_numchars_on_line(e, e->buffy)>e->buffx) {
+  if (owl_editwin_get_numchars_on_line(e, e->buffy) > e->buffx) {
     /* normal line */
     i=_owl_editwin_get_index_from_xy(e);
@@ -804,5 +932,5 @@
 void owl_editwin_move_to_line_end(owl_editwin *e)
 {
-  e->buffx=owl_editwin_get_numchars_on_line(e, e->buffy);
+  e->buffx=owl_editwin_get_numcells_on_line(e, e->buffy);
 }
 
@@ -817,5 +945,5 @@
   /* go to last char */
   e->buffy=owl_editwin_get_numlines(e)-1;
-  e->buffx=owl_editwin_get_numchars_on_line(e, e->buffy);
+  e->buffx=owl_editwin_get_numcells_on_line(e, e->buffy);
   owl_editwin_key_right(e);
 
@@ -841,4 +969,5 @@
 void owl_editwin_fill_paragraph(owl_editwin *e)
 {
+  /* asedeno: needs fixing for utf-8*/
   int i, save;
 
@@ -857,11 +986,11 @@
   /* main loop */
   while (1) {
-    i=_owl_editwin_get_index_from_xy(e);
+    i = _owl_editwin_get_index_from_xy(e);
 
     /* bail if we hit the end of the buffer */
-    if (i>=e->bufflen) break;
+    if (i >= e->bufflen || e->buff[i] == '\0') break;
 
     /* bail if we hit the end of the paragraph */
-    if (e->buff[i]=='\n' && e->buff[i+1]=='\n') break;
+    if (e->buff[i] == '\n' && e->buff[i+1] == '\n') break;
 
     /* if we've travelled too far, linewrap */
@@ -871,6 +1000,6 @@
 
     /* did we hit the end of a line too soon? */
-    i=_owl_editwin_get_index_from_xy(e);
-    if (e->buff[i]=='\n' && e->buffx<e->fillcol-1) {
+    i = _owl_editwin_get_index_from_xy(e);
+    if (e->buff[i] == '\n' && e->buffx < e->fillcol - 1) {
       /* ********* we need to make sure we don't pull in a word that's too long ***********/
       e->buff[i]=' ';
@@ -878,12 +1007,12 @@
     
     /* fix spacing */
-    i=_owl_editwin_get_index_from_xy(e);
-    if (e->buff[i]==' ' && e->buff[i+1]==' ') {
-      if (e->buff[i-1]=='.' || e->buff[i-1]=='!' || e->buff[i-1]=='?') {
+    i = _owl_editwin_get_index_from_xy(e);
+    if (e->buff[i] == ' ' && e->buff[i+1] == ' ') {
+      if (e->buff[i-1] == '.' || e->buff[i-1] == '!' || e->buff[i-1] == '?') {
 	owl_editwin_key_right(e);
       } else {
 	owl_editwin_delete_char(e);
 	/* if we did this ahead of the save point, adjust it */
-	if (i<save) save--;
+	if (i < save) save--;
       }
     } else {
@@ -911,23 +1040,31 @@
 int owl_editwin_check_dotsend(owl_editwin *e)
 {
-  int i;
+  char *p, *p_n, *p_p;
+  gunichar c;
 
   if (!e->dotsend) return(0);
-  for (i=e->bufflen-1; i>0; i--) {
-    if (e->buff[i] == '.' 
-	&& (e->buff[i-1] == '\n' || e->buff[i-1] == '\r')
-	&& (e->buff[i+1] == '\n' || e->buff[i+1] == '\r')) {
-      e->bufflen = i;
-      e->buff[i] = '\0';
+
+  p = g_utf8_find_prev_char(e->buff, e->buff + e->bufflen);
+  p_n = g_utf8_find_next_char(p, NULL);
+  p_p = g_utf8_find_prev_char(e->buff, p);
+  c = g_utf8_get_char(p);
+  while (p != NULL) {
+    if (*p == '.'
+	&& p_p != NULL && (*p_p == '\n' || *p_p == '\r')
+	&& p_n != NULL && (*p_n == '\n' || *p_n == '\r')) {
+      e->bufflen = p - e->buff;
+      e->buff[e->bufflen] = '\0';
       return(1);
     }
-    if (!isspace((int) e->buff[i])) {
-      return(0);
-    }
+    if (c != '\0' && !g_unichar_isspace(c)) return(0);
+    p_n = p;
+    p = p_p;
+    c = g_utf8_get_char(p);
+    p_p = g_utf8_find_prev_char(e->buff, p);
   }
   return(0);
 }
 
-void owl_editwin_post_process_char(owl_editwin *e, int j)
+void owl_editwin_post_process_char(owl_editwin *e, gunichar j)
 {
   /* check if we need to scroll down */
@@ -942,10 +1079,11 @@
 }
 
-void owl_editwin_process_char(owl_editwin *e, int j)
+void owl_editwin_process_char(owl_editwin *e, gunichar j)
 {
   if (j == ERR) return;
-  if (j>127 || ((j<32) && (j!=10) && (j!=13))) {
+  if (g_unichar_iscntrl(j) && (j != 10) && (j != 13)) {
     return;
-  } else {
+  }
+  else {
     owl_editwin_insert_char(e, j);
   }
@@ -975,10 +1113,44 @@
   }
 
-  /* now go to the xth character */
-  ptr2=strchr(ptr1, '\n');
-  if (!ptr2) {
-    return(e->buff + e->bufflen - ptr1);
-  }
-  return(ptr2-ptr1); /* don't count the newline for now */
+  /* now count characters */
+  i = 0;
+  ptr2 = ptr1;
+  while (ptr2 - e->buff < e->bufflen
+	 && *ptr2 != '\n') {
+    ++i;
+    ptr2 = g_utf8_next_char(ptr2);
+  }
+  return i;
+}
+
+int owl_editwin_get_numcells_on_line(owl_editwin *e, int line)
+{
+  int i;
+  char *ptr1, *ptr2;
+  gunichar c;
+
+  if (e->bufflen==0) return(0);
+  
+  /* first go to the yth line */
+  ptr1=e->buff;
+  for (i=0; i<line; i++) {
+    ptr2=strchr(ptr1, '\n');
+    if (!ptr2) {
+      /* we're already on the last line */
+      return(0);
+    }
+    ptr1=ptr2+1;
+  }
+
+  /* now count cells */
+  i = 0;
+  ptr2 = ptr1;
+  while (ptr2 - e->buff < e->bufflen
+	 && *ptr2 != '\n') {
+    c = g_utf8_get_char(ptr2);
+    i += mk_wcwidth(c);
+    ptr2 = g_utf8_next_char(ptr2);
+  }
+  return i;
 }
 
Index: fmtext.c
===================================================================
--- fmtext.c	(revision 5376a95c0ff753a89c734d966bf048447b90f3db)
+++ fmtext.c	(revision 47519e1bcab60a6026c4192bf5b20290f37f4737)
@@ -248,5 +248,5 @@
  * must already be initiatlized with curses
  */
-void owl_fmtext_curs_waddstr(owl_fmtext *f, WINDOW *w, int do_search)
+void _owl_fmtext_curs_waddstr(owl_fmtext *f, WINDOW *w, int do_search) /*noproto*/
 {
   /* char *tmpbuff; */
@@ -264,6 +264,8 @@
   search_results = (do_search
 		    ? owl_fmtext_search(f, owl_global_get_search_string(&g))
-		    : NULL);
-  if (search_results) search_len = strlen(owl_global_get_search_string(&g));
+		    : 0);
+  search_len = (search_results
+		? strlen(owl_global_get_search_string(&g))
+		: 0);
   s = f->textbuff;
   /* Set default attributes. */
@@ -350,4 +352,13 @@
 }
 
+void owl_fmtext_curs_waddstr(owl_fmtext *f, WINDOW *w)
+{
+  _owl_fmtext_curs_waddstr(f, w, owl_global_is_search_active(&g));
+}
+
+void owl_fmtext_curs_waddstr_without_search(owl_fmtext *f, WINDOW *w)
+{
+  _owl_fmtext_curs_waddstr(f, w, 0);
+}
 
 /* start with line 'aline' (where the first line is 0) and print
@@ -413,9 +424,10 @@
     st = 0;
     padding = 0;
+    chwidth = 0;
     ptr_c = ptr_s;
     while(col <= bcol && ptr_c < ptr_e) {
       gunichar c = g_utf8_get_char(ptr_c);
       if (!_owl_fmtext_is_format_char(c)) {
-	chwidth = wcwidth(c);
+	chwidth = mk_wcwidth(c);
       
 	if (col + chwidth > bcol)
Index: functions.c
===================================================================
--- functions.c	(revision 36172860060e404e761fc6fd5503c09ef88bd83d)
+++ functions.c	(revision 47519e1bcab60a6026c4192bf5b20290f37f4737)
@@ -2187,5 +2187,4 @@
 void owl_function_start_command(char *line)
 {
-  int i, j;
   owl_editwin *tw;
 
@@ -2198,8 +2197,5 @@
   owl_global_set_needrefresh(&g);
 
-  j=strlen(line);
-  for (i=0; i<j; i++) {
-    owl_editwin_process_char(tw, line[i]);
-  }
+  owl_editwin_insert_string(tw, line);
   owl_editwin_redisplay(tw, 0);
 
Index: keymap.c
===================================================================
--- keymap.c	(revision cf83b7a15ef998b48ca0aa69dae69a963b365dc1)
+++ keymap.c	(revision 47519e1bcab60a6026c4192bf5b20290f37f4737)
@@ -202,5 +202,5 @@
 /* processes a keypress.  returns 0 if the keypress was handled,
  * 1 if not handled, -1 on error, and -2 if j==ERR. */
-int owl_keyhandler_process(owl_keyhandler *kh, int j)
+int owl_keyhandler_process(owl_keyhandler *kh, gunichar j)
 {
   owl_keymap     *km;
Index: message.c
===================================================================
--- message.c	(revision 62016463b9add34672342c83beef28abe3f75476)
+++ message.c	(revision 47519e1bcab60a6026c4192bf5b20290f37f4737)
@@ -540,5 +540,5 @@
   owl_fmtext_colorizebg(&b, bgcolor);
 
-  owl_fmtext_curs_waddstr(&b, win, owl_global_is_search_active(&g));
+  owl_fmtext_curs_waddstr(&b, win);
 
   owl_fmtext_free(&a);
Index: owl.c
===================================================================
--- owl.c	(revision 89f5338caeb1828d0000cccaf478f1808203a6b1)
+++ owl.c	(revision 47519e1bcab60a6026c4192bf5b20290f37f4737)
@@ -70,5 +70,6 @@
   owl_editwin *tw;
   owl_popwin *pw;
-  int j, ret, initialsubs, debug, argcsave, followlast;
+  int ret, initialsubs, debug, argcsave, followlast;
+  gunichar j;
   int newmsgs, nexttimediff;
   struct sigaction sigact;
@@ -546,4 +547,28 @@
       usleep(10000);
     } else {
+      /* Pull in a full utf-8 character. */
+      if (j & 0x80) {
+	char utf8buf[7];
+	int bytes, i;
+	memset(utf8buf,'\0',7);
+	utf8buf[0] = j;
+
+	if (~j & 0x20) bytes = 2;
+	else if (~j & 0x10) bytes = 3;
+	else if (~j & 0x08) bytes = 4;
+	else if (~j & 0x04) bytes = 5;
+	else if (~j & 0x02) bytes = 6;
+	else bytes = 1; /* This won't validate */
+
+	for (i = 1; i < bytes; i++) {
+	  utf8buf[i] = wgetch(typwin);
+	}
+	if (g_utf8_validate(utf8buf, -1, NULL)) {
+	  j = g_utf8_get_char(utf8buf);
+	}
+	else {
+	  j = ERR;
+	}
+      }
       owl_global_update_lastinputtime(&g);
       /* find and activate the current keymap.
Index: text.c
===================================================================
--- text.c	(revision dd24b6a9702baf822973cf963adfd8b55978b775)
+++ text.c	(revision 47519e1bcab60a6026c4192bf5b20290f37f4737)
@@ -77,6 +77,6 @@
     while(col < bcol && ptr_c < ptr_e) {
       gunichar c = g_utf8_get_char(ptr_c);
-      if (col + wcwidth(c) > bcol) break;
-      col += wcwidth(c);
+      if (col + mk_wcwidth(c) > bcol) break;
+      col += mk_wcwidth(c);
       ptr_c = g_utf8_next_char(ptr_c);
       if (col >= acol) {
Index: viewwin.c
===================================================================
--- viewwin.c	(revision 9866c3aac7b8bd2779303753d2e1352f405b2baf)
+++ viewwin.c	(revision 47519e1bcab60a6026c4192bf5b20290f37f4737)
@@ -73,5 +73,5 @@
   owl_fmtext_truncate_cols(&fm1, v->rightshift, v->wincols-1+v->rightshift, &fm2);
 
-  owl_fmtext_curs_waddstr(&fm2, v->curswin, 0);
+  owl_fmtext_curs_waddstr_without_search(&fm2, v->curswin);
 
   /* print the message at the bottom */
Index: wcwidth.c
===================================================================
--- wcwidth.c	(revision 47519e1bcab60a6026c4192bf5b20290f37f4737)
+++ wcwidth.c	(revision 47519e1bcab60a6026c4192bf5b20290f37f4737)
@@ -0,0 +1,309 @@
+/*
+ * This is an implementation of wcwidth() and wcswidth() (defined in
+ * IEEE Std 1002.1-2001) for Unicode.
+ *
+ * http://www.opengroup.org/onlinepubs/007904975/functions/wcwidth.html
+ * http://www.opengroup.org/onlinepubs/007904975/functions/wcswidth.html
+ *
+ * In fixed-width output devices, Latin characters all occupy a single
+ * "cell" position of equal width, whereas ideographic CJK characters
+ * occupy two such cells. Interoperability between terminal-line
+ * applications and (teletype-style) character terminals using the
+ * UTF-8 encoding requires agreement on which character should advance
+ * the cursor by how many cell positions. No established formal
+ * standards exist at present on which Unicode character shall occupy
+ * how many cell positions on character terminals. These routines are
+ * a first attempt of defining such behavior based on simple rules
+ * applied to data provided by the Unicode Consortium.
+ *
+ * For some graphical characters, the Unicode standard explicitly
+ * defines a character-cell width via the definition of the East Asian
+ * FullWidth (F), Wide (W), Half-width (H), and Narrow (Na) classes.
+ * In all these cases, there is no ambiguity about which width a
+ * terminal shall use. For characters in the East Asian Ambiguous (A)
+ * class, the width choice depends purely on a preference of backward
+ * compatibility with either historic CJK or Western practice.
+ * Choosing single-width for these characters is easy to justify as
+ * the appropriate long-term solution, as the CJK practice of
+ * displaying these characters as double-width comes from historic
+ * implementation simplicity (8-bit encoded characters were displayed
+ * single-width and 16-bit ones double-width, even for Greek,
+ * Cyrillic, etc.) and not any typographic considerations.
+ *
+ * Much less clear is the choice of width for the Not East Asian
+ * (Neutral) class. Existing practice does not dictate a width for any
+ * of these characters. It would nevertheless make sense
+ * typographically to allocate two character cells to characters such
+ * as for instance EM SPACE or VOLUME INTEGRAL, which cannot be
+ * represented adequately with a single-width glyph. The following
+ * routines at present merely assign a single-cell width to all
+ * neutral characters, in the interest of simplicity. This is not
+ * entirely satisfactory and should be reconsidered before
+ * establishing a formal standard in this area. At the moment, the
+ * decision which Not East Asian (Neutral) characters should be
+ * represented by double-width glyphs cannot yet be answered by
+ * applying a simple rule from the Unicode database content. Setting
+ * up a proper standard for the behavior of UTF-8 character terminals
+ * will require a careful analysis not only of each Unicode character,
+ * but also of each presentation form, something the author of these
+ * routines has avoided to do so far.
+ *
+ * http://www.unicode.org/unicode/reports/tr11/
+ *
+ * Markus Kuhn -- 2007-05-26 (Unicode 5.0)
+ *
+ * Permission to use, copy, modify, and distribute this software
+ * for any purpose and without fee is hereby granted. The author
+ * disclaims all warranties with regard to this software.
+ *
+ * Latest version: http://www.cl.cam.ac.uk/~mgk25/ucs/wcwidth.c
+ */
+
+#include <wchar.h>
+
+static struct interval {
+  int first;
+  int last;
+};
+
+/* auxiliary function for binary search in interval table */
+static int bisearch(wchar_t ucs, const struct interval *table, int max) {
+  int min = 0;
+  int mid;
+
+  if (ucs < table[0].first || ucs > table[max].last)
+    return 0;
+  while (max >= min) {
+    mid = (min + max) / 2;
+    if (ucs > table[mid].last)
+      min = mid + 1;
+    else if (ucs < table[mid].first)
+      max = mid - 1;
+    else
+      return 1;
+  }
+
+  return 0;
+}
+
+
+/* The following two functions define the column width of an ISO 10646
+ * character as follows:
+ *
+ *    - The null character (U+0000) has a column width of 0.
+ *
+ *    - Other C0/C1 control characters and DEL will lead to a return
+ *      value of -1.
+ *
+ *    - Non-spacing and enclosing combining characters (general
+ *      category code Mn or Me in the Unicode database) have a
+ *      column width of 0.
+ *
+ *    - SOFT HYPHEN (U+00AD) has a column width of 1.
+ *
+ *    - Other format characters (general category code Cf in the Unicode
+ *      database) and ZERO WIDTH SPACE (U+200B) have a column width of 0.
+ *
+ *    - Hangul Jamo medial vowels and final consonants (U+1160-U+11FF)
+ *      have a column width of 0.
+ *
+ *    - Spacing characters in the East Asian Wide (W) or East Asian
+ *      Full-width (F) category as defined in Unicode Technical
+ *      Report #11 have a column width of 2.
+ *
+ *    - All remaining characters (including all printable
+ *      ISO 8859-1 and WGL4 characters, Unicode control characters,
+ *      etc.) have a column width of 1.
+ *
+ * This implementation assumes that wchar_t characters are encoded
+ * in ISO 10646.
+ */
+
+int mk_wcwidth(wchar_t ucs)
+{
+  /* sorted list of non-overlapping intervals of non-spacing characters */
+  /* generated by "uniset +cat=Me +cat=Mn +cat=Cf -00AD +1160-11FF +200B c" */
+  static const struct interval combining[] = {
+    { 0x0300, 0x036F }, { 0x0483, 0x0486 }, { 0x0488, 0x0489 },
+    { 0x0591, 0x05BD }, { 0x05BF, 0x05BF }, { 0x05C1, 0x05C2 },
+    { 0x05C4, 0x05C5 }, { 0x05C7, 0x05C7 }, { 0x0600, 0x0603 },
+    { 0x0610, 0x0615 }, { 0x064B, 0x065E }, { 0x0670, 0x0670 },
+    { 0x06D6, 0x06E4 }, { 0x06E7, 0x06E8 }, { 0x06EA, 0x06ED },
+    { 0x070F, 0x070F }, { 0x0711, 0x0711 }, { 0x0730, 0x074A },
+    { 0x07A6, 0x07B0 }, { 0x07EB, 0x07F3 }, { 0x0901, 0x0902 },
+    { 0x093C, 0x093C }, { 0x0941, 0x0948 }, { 0x094D, 0x094D },
+    { 0x0951, 0x0954 }, { 0x0962, 0x0963 }, { 0x0981, 0x0981 },
+    { 0x09BC, 0x09BC }, { 0x09C1, 0x09C4 }, { 0x09CD, 0x09CD },
+    { 0x09E2, 0x09E3 }, { 0x0A01, 0x0A02 }, { 0x0A3C, 0x0A3C },
+    { 0x0A41, 0x0A42 }, { 0x0A47, 0x0A48 }, { 0x0A4B, 0x0A4D },
+    { 0x0A70, 0x0A71 }, { 0x0A81, 0x0A82 }, { 0x0ABC, 0x0ABC },
+    { 0x0AC1, 0x0AC5 }, { 0x0AC7, 0x0AC8 }, { 0x0ACD, 0x0ACD },
+    { 0x0AE2, 0x0AE3 }, { 0x0B01, 0x0B01 }, { 0x0B3C, 0x0B3C },
+    { 0x0B3F, 0x0B3F }, { 0x0B41, 0x0B43 }, { 0x0B4D, 0x0B4D },
+    { 0x0B56, 0x0B56 }, { 0x0B82, 0x0B82 }, { 0x0BC0, 0x0BC0 },
+    { 0x0BCD, 0x0BCD }, { 0x0C3E, 0x0C40 }, { 0x0C46, 0x0C48 },
+    { 0x0C4A, 0x0C4D }, { 0x0C55, 0x0C56 }, { 0x0CBC, 0x0CBC },
+    { 0x0CBF, 0x0CBF }, { 0x0CC6, 0x0CC6 }, { 0x0CCC, 0x0CCD },
+    { 0x0CE2, 0x0CE3 }, { 0x0D41, 0x0D43 }, { 0x0D4D, 0x0D4D },
+    { 0x0DCA, 0x0DCA }, { 0x0DD2, 0x0DD4 }, { 0x0DD6, 0x0DD6 },
+    { 0x0E31, 0x0E31 }, { 0x0E34, 0x0E3A }, { 0x0E47, 0x0E4E },
+    { 0x0EB1, 0x0EB1 }, { 0x0EB4, 0x0EB9 }, { 0x0EBB, 0x0EBC },
+    { 0x0EC8, 0x0ECD }, { 0x0F18, 0x0F19 }, { 0x0F35, 0x0F35 },
+    { 0x0F37, 0x0F37 }, { 0x0F39, 0x0F39 }, { 0x0F71, 0x0F7E },
+    { 0x0F80, 0x0F84 }, { 0x0F86, 0x0F87 }, { 0x0F90, 0x0F97 },
+    { 0x0F99, 0x0FBC }, { 0x0FC6, 0x0FC6 }, { 0x102D, 0x1030 },
+    { 0x1032, 0x1032 }, { 0x1036, 0x1037 }, { 0x1039, 0x1039 },
+    { 0x1058, 0x1059 }, { 0x1160, 0x11FF }, { 0x135F, 0x135F },
+    { 0x1712, 0x1714 }, { 0x1732, 0x1734 }, { 0x1752, 0x1753 },
+    { 0x1772, 0x1773 }, { 0x17B4, 0x17B5 }, { 0x17B7, 0x17BD },
+    { 0x17C6, 0x17C6 }, { 0x17C9, 0x17D3 }, { 0x17DD, 0x17DD },
+    { 0x180B, 0x180D }, { 0x18A9, 0x18A9 }, { 0x1920, 0x1922 },
+    { 0x1927, 0x1928 }, { 0x1932, 0x1932 }, { 0x1939, 0x193B },
+    { 0x1A17, 0x1A18 }, { 0x1B00, 0x1B03 }, { 0x1B34, 0x1B34 },
+    { 0x1B36, 0x1B3A }, { 0x1B3C, 0x1B3C }, { 0x1B42, 0x1B42 },
+    { 0x1B6B, 0x1B73 }, { 0x1DC0, 0x1DCA }, { 0x1DFE, 0x1DFF },
+    { 0x200B, 0x200F }, { 0x202A, 0x202E }, { 0x2060, 0x2063 },
+    { 0x206A, 0x206F }, { 0x20D0, 0x20EF }, { 0x302A, 0x302F },
+    { 0x3099, 0x309A }, { 0xA806, 0xA806 }, { 0xA80B, 0xA80B },
+    { 0xA825, 0xA826 }, { 0xFB1E, 0xFB1E }, { 0xFE00, 0xFE0F },
+    { 0xFE20, 0xFE23 }, { 0xFEFF, 0xFEFF }, { 0xFFF9, 0xFFFB },
+    { 0x10A01, 0x10A03 }, { 0x10A05, 0x10A06 }, { 0x10A0C, 0x10A0F },
+    { 0x10A38, 0x10A3A }, { 0x10A3F, 0x10A3F }, { 0x1D167, 0x1D169 },
+    { 0x1D173, 0x1D182 }, { 0x1D185, 0x1D18B }, { 0x1D1AA, 0x1D1AD },
+    { 0x1D242, 0x1D244 }, { 0xE0001, 0xE0001 }, { 0xE0020, 0xE007F },
+    { 0xE0100, 0xE01EF }
+  };
+
+  /* test for 8-bit control characters */
+  if (ucs == 0)
+    return 0;
+  if (ucs < 32 || (ucs >= 0x7f && ucs < 0xa0))
+    return -1;
+
+  /* binary search in table of non-spacing characters */
+  if (bisearch(ucs, combining,
+	       sizeof(combining) / sizeof(struct interval) - 1))
+    return 0;
+
+  /* if we arrive here, ucs is not a combining or C0/C1 control character */
+
+  return 1 + 
+    (ucs >= 0x1100 &&
+     (ucs <= 0x115f ||                    /* Hangul Jamo init. consonants */
+      ucs == 0x2329 || ucs == 0x232a ||
+      (ucs >= 0x2e80 && ucs <= 0xa4cf &&
+       ucs != 0x303f) ||                  /* CJK ... Yi */
+      (ucs >= 0xac00 && ucs <= 0xd7a3) || /* Hangul Syllables */
+      (ucs >= 0xf900 && ucs <= 0xfaff) || /* CJK Compatibility Ideographs */
+      (ucs >= 0xfe10 && ucs <= 0xfe19) || /* Vertical forms */
+      (ucs >= 0xfe30 && ucs <= 0xfe6f) || /* CJK Compatibility Forms */
+      (ucs >= 0xff00 && ucs <= 0xff60) || /* Fullwidth Forms */
+      (ucs >= 0xffe0 && ucs <= 0xffe6) ||
+      (ucs >= 0x20000 && ucs <= 0x2fffd) ||
+      (ucs >= 0x30000 && ucs <= 0x3fffd)));
+}
+
+
+int mk_wcswidth(const wchar_t *pwcs, size_t n)
+{
+  int w, width = 0;
+
+  for (;*pwcs && n-- > 0; pwcs++)
+    if ((w = mk_wcwidth(*pwcs)) < 0)
+      return -1;
+    else
+      width += w;
+
+  return width;
+}
+
+
+/*
+ * The following functions are the same as mk_wcwidth() and
+ * mk_wcswidth(), except that spacing characters in the East Asian
+ * Ambiguous (A) category as defined in Unicode Technical Report #11
+ * have a column width of 2. This variant might be useful for users of
+ * CJK legacy encodings who want to migrate to UCS without changing
+ * the traditional terminal character-width behaviour. It is not
+ * otherwise recommended for general use.
+ */
+int mk_wcwidth_cjk(wchar_t ucs)
+{
+  /* sorted list of non-overlapping intervals of East Asian Ambiguous
+   * characters, generated by "uniset +WIDTH-A -cat=Me -cat=Mn -cat=Cf c" */
+  static const struct interval ambiguous[] = {
+    { 0x00A1, 0x00A1 }, { 0x00A4, 0x00A4 }, { 0x00A7, 0x00A8 },
+    { 0x00AA, 0x00AA }, { 0x00AE, 0x00AE }, { 0x00B0, 0x00B4 },
+    { 0x00B6, 0x00BA }, { 0x00BC, 0x00BF }, { 0x00C6, 0x00C6 },
+    { 0x00D0, 0x00D0 }, { 0x00D7, 0x00D8 }, { 0x00DE, 0x00E1 },
+    { 0x00E6, 0x00E6 }, { 0x00E8, 0x00EA }, { 0x00EC, 0x00ED },
+    { 0x00F0, 0x00F0 }, { 0x00F2, 0x00F3 }, { 0x00F7, 0x00FA },
+    { 0x00FC, 0x00FC }, { 0x00FE, 0x00FE }, { 0x0101, 0x0101 },
+    { 0x0111, 0x0111 }, { 0x0113, 0x0113 }, { 0x011B, 0x011B },
+    { 0x0126, 0x0127 }, { 0x012B, 0x012B }, { 0x0131, 0x0133 },
+    { 0x0138, 0x0138 }, { 0x013F, 0x0142 }, { 0x0144, 0x0144 },
+    { 0x0148, 0x014B }, { 0x014D, 0x014D }, { 0x0152, 0x0153 },
+    { 0x0166, 0x0167 }, { 0x016B, 0x016B }, { 0x01CE, 0x01CE },
+    { 0x01D0, 0x01D0 }, { 0x01D2, 0x01D2 }, { 0x01D4, 0x01D4 },
+    { 0x01D6, 0x01D6 }, { 0x01D8, 0x01D8 }, { 0x01DA, 0x01DA },
+    { 0x01DC, 0x01DC }, { 0x0251, 0x0251 }, { 0x0261, 0x0261 },
+    { 0x02C4, 0x02C4 }, { 0x02C7, 0x02C7 }, { 0x02C9, 0x02CB },
+    { 0x02CD, 0x02CD }, { 0x02D0, 0x02D0 }, { 0x02D8, 0x02DB },
+    { 0x02DD, 0x02DD }, { 0x02DF, 0x02DF }, { 0x0391, 0x03A1 },
+    { 0x03A3, 0x03A9 }, { 0x03B1, 0x03C1 }, { 0x03C3, 0x03C9 },
+    { 0x0401, 0x0401 }, { 0x0410, 0x044F }, { 0x0451, 0x0451 },
+    { 0x2010, 0x2010 }, { 0x2013, 0x2016 }, { 0x2018, 0x2019 },
+    { 0x201C, 0x201D }, { 0x2020, 0x2022 }, { 0x2024, 0x2027 },
+    { 0x2030, 0x2030 }, { 0x2032, 0x2033 }, { 0x2035, 0x2035 },
+    { 0x203B, 0x203B }, { 0x203E, 0x203E }, { 0x2074, 0x2074 },
+    { 0x207F, 0x207F }, { 0x2081, 0x2084 }, { 0x20AC, 0x20AC },
+    { 0x2103, 0x2103 }, { 0x2105, 0x2105 }, { 0x2109, 0x2109 },
+    { 0x2113, 0x2113 }, { 0x2116, 0x2116 }, { 0x2121, 0x2122 },
+    { 0x2126, 0x2126 }, { 0x212B, 0x212B }, { 0x2153, 0x2154 },
+    { 0x215B, 0x215E }, { 0x2160, 0x216B }, { 0x2170, 0x2179 },
+    { 0x2190, 0x2199 }, { 0x21B8, 0x21B9 }, { 0x21D2, 0x21D2 },
+    { 0x21D4, 0x21D4 }, { 0x21E7, 0x21E7 }, { 0x2200, 0x2200 },
+    { 0x2202, 0x2203 }, { 0x2207, 0x2208 }, { 0x220B, 0x220B },
+    { 0x220F, 0x220F }, { 0x2211, 0x2211 }, { 0x2215, 0x2215 },
+    { 0x221A, 0x221A }, { 0x221D, 0x2220 }, { 0x2223, 0x2223 },
+    { 0x2225, 0x2225 }, { 0x2227, 0x222C }, { 0x222E, 0x222E },
+    { 0x2234, 0x2237 }, { 0x223C, 0x223D }, { 0x2248, 0x2248 },
+    { 0x224C, 0x224C }, { 0x2252, 0x2252 }, { 0x2260, 0x2261 },
+    { 0x2264, 0x2267 }, { 0x226A, 0x226B }, { 0x226E, 0x226F },
+    { 0x2282, 0x2283 }, { 0x2286, 0x2287 }, { 0x2295, 0x2295 },
+    { 0x2299, 0x2299 }, { 0x22A5, 0x22A5 }, { 0x22BF, 0x22BF },
+    { 0x2312, 0x2312 }, { 0x2460, 0x24E9 }, { 0x24EB, 0x254B },
+    { 0x2550, 0x2573 }, { 0x2580, 0x258F }, { 0x2592, 0x2595 },
+    { 0x25A0, 0x25A1 }, { 0x25A3, 0x25A9 }, { 0x25B2, 0x25B3 },
+    { 0x25B6, 0x25B7 }, { 0x25BC, 0x25BD }, { 0x25C0, 0x25C1 },
+    { 0x25C6, 0x25C8 }, { 0x25CB, 0x25CB }, { 0x25CE, 0x25D1 },
+    { 0x25E2, 0x25E5 }, { 0x25EF, 0x25EF }, { 0x2605, 0x2606 },
+    { 0x2609, 0x2609 }, { 0x260E, 0x260F }, { 0x2614, 0x2615 },
+    { 0x261C, 0x261C }, { 0x261E, 0x261E }, { 0x2640, 0x2640 },
+    { 0x2642, 0x2642 }, { 0x2660, 0x2661 }, { 0x2663, 0x2665 },
+    { 0x2667, 0x266A }, { 0x266C, 0x266D }, { 0x266F, 0x266F },
+    { 0x273D, 0x273D }, { 0x2776, 0x277F }, { 0xE000, 0xF8FF },
+    { 0xFFFD, 0xFFFD }, { 0xF0000, 0xFFFFD }, { 0x100000, 0x10FFFD }
+  };
+
+  /* binary search in table of non-spacing characters */
+  if (bisearch(ucs, ambiguous,
+	       sizeof(ambiguous) / sizeof(struct interval) - 1))
+    return 2;
+
+  return mk_wcwidth(ucs);
+}
+
+
+int mk_wcswidth_cjk(const wchar_t *pwcs, size_t n)
+{
+  int w, width = 0;
+
+  for (;*pwcs && n-- > 0; pwcs++)
+    if ((w = mk_wcwidth_cjk(*pwcs)) < 0)
+      return -1;
+    else
+      width += w;
+
+  return width;
+}
